% menu item: load

while 2,
  clc
  choice1=menu('Load','Data points','Spline Parameter',...
      'Free knots','Quit');
  
  if ((choice1<=0) | (choice1>=4))
    break
  end            
      
  if choice1==1                               % Data points
    while 3,
      clc
      choice2=menu('Read data points','M-File (with knots)',...
          'Franke Exponential m1, m2 arbitrary',...
          'Bivariate Titanium m1=49, m2=49',...
          'Dierckx Data m1=30, m2=30',...
          'Carlson-Fritsch EOS Alu Data m1=10, m2=6',...
          'Other data','Quit');
        
      if ((choice2<=0) | (choice2>=7))
        break
      end   
          
    
      if choice2==1                           % M-File
        % read ASCII-File with x1, x2, and Y
        Filename=uigetfile('*.m','Enter file name:');
        fid=fopen(Filename);
        
        matrix=fscanf(fid,'%g',[m2+1, inf]);
        matrix=matrix';
        
        x1=matrix(2:m1+1,1:1);
        x2=matrix(1:1,2:m2+1);
        Y=matrix(2:m1+1,2:m2+1);
        x1=x1(:);
        x2=x2(:);
        fclose(fid);
        clear matrix
      elseif choice2==2                       % Franke Exponential
        x1=linspace(0,1,m1);
        x2=linspace(0,1,m2);
        Y=franke(x1'*ones(1,length(x2)),ones(length(x1),1)*x2);
        delta=readnum('Variance of random errors',0.05);
        Y=Y+delta*randn(size(Y));
        x1=x1(:);
        x2=x2(:);
      elseif choice2==3                       % Bivariate Titanium
        [x1,x2,Y]=feval('bititan');
      elseif choice2==4                       % Dierckx Data
        [x1,x2,Y]=feval('dierckx');
      elseif choice2==5                       % EOS Alu data
        [x1,x2,Y]=feval('eosalu');
      elseif choice2==6                       % other data  
        Filename=readchar('Enter file name (without extension)','eosalu');
        [x1,x2,Y]=feval(Filename);
      end % if choice2
      
      m1=length(x1);
      m2=length(x2);
    end % while 3
  elseif choice1==2                           % Spline Parameter
    while 3,
      clc
      choice2=menu('Load Spline parameter','Keyboard (only knots)',...
          'M-File','Standard knotsequence (equidistant)','Quit');
      
      if ((choice2<=0) | (choice2>=4))
        break
      end   
      
      if choice2==1                           % Keyboard
        % Input inner knots of knot sequence t1
        t1=zeros(n1+k1,1);
        for i=k1:n1+1
          clc
          home
          t1(i)=input(['Input inner knot t1( ' num2str(i) ' ): ']);
        end % for i
            
        t1(1:k1-1)=t1(k1).*ones(k1-1,1); 
        t1(n1+2:n1+k1)=t1(n1+1).*ones(k1-1,1);
        
        % Input inner knots of knot sequence t2
        t2=zeros(n2+k2,1);
        for i=k2:n2+1
          clc
          home
          t2(i)=input(['Input inner knot t2( ' num2str(i) ' ): ']);
        end % for i
            
        t2(1:k2-1)=t2(k2).*ones(k2-1,1); 
        t2(n2+2:n2+k2)=t2(n2+1).*ones(k2-1,1);
      elseif choice2==2                       % M-File
        % read ASCII-File with t1, t2, and A
        Filename=uigetfile('*.m','Enter file name:');
        fid=fopen(Filename);
        
        matrix=fscanf(fid,'%g',[n2+k2+1, inf]);
        matrix=matrix';
        
        t1=matrix(2:n1+k1+1,1:1);
        t2=matrix(1:1,2:n2+k2+1);
        A=matrix(2:n1+1,2:n2+1);
        t1=t1(:);
        t2=t2(:);
        fclose(fid);
        clear matrix
      elseif choice2==3                       % Standard knotsquence
        
        t1=zeros(n1+k1,1);
     
        for j=1:k1
          t1(j)=x1(1);
        end
        for j=k1+1:n1
          t1(j)=x1(1)+(j-k1)*(x1(m1)-x1(1))/(n1-k1+1);
        end
        for j=n1+1:n1+k1
          t1(j)=x1(m1);
        end
          
        t2=zeros(n2+k2,1);
     
        for j=1:k2
          t2(j)=x2(1);
        end
        for j=k2+1:n2
          t2(j)=x2(1)+(j-k2)*(x2(m2)-x2(1))/(n2-k2+1);
        end
        for j=n2+1:n2+k2
          t2(j)=x2(m2);
        end
        
      end % if choice2
    end % while 3   
  elseif choice1==3                           % Free knots
    % Input number of free knots
    l1=readnum('Number of free knots in x-direction l1 <= n1-k1',n1-k1);
        
    pvec1=zeros(l1,1);
    if l1==n1-k1
      allinner=readchar('Set all inner knots free (y/n)','y');
      if allinner=='y'
        for i=1:l1
          pvec1(i)=k1+i;
        end
      else
        allinner='n'
      end
    else
      allinner='n'
    end
    
    if allinner=='n'
      for i=1:l1
        clc
        home
        % Input index vector of free knots
        pvec1(i)=input(['Enter index of ' num2str(i) ' -th free knot: ']);
      end % for i
    end
    
    EPSILON1=readnum('Minimum distance between knots in x-direction',0.0625);
    
    % Input number of free knots
    l2=readnum('Number of free knots in y-direction l2 <= n2-k2',n2-k2);
        
    pvec2=zeros(l2,1);
    if l2==n2-k2
      allinner=readchar('Set all inner knots free (y/n)','y');
      if allinner=='y'
        for i=1:l2
          pvec2(i)=k2+i;
        end
      else
        allinner='n'
      end
    else
      allinner='n'
    end
    
    if allinner=='n'
      for i=1:l2
        clc
        home
        % Input index vector of free knots
        pvec2(i)=input(['Enter index of ' num2str(i) ' -th free knot: ']);
      end % for i
    end
    
    EPSILON2=readnum('Minimum distance between knots in y-direction',0.0625);
    
  end  % if choice1
end % while 2