function [F,FJac]=nlsfun(x);
% function [F,FJac]=nlsfun(x);
%
% compute residual function of reduced functional and set dummy Jacobian
% FJac=[]

% get global variables for nlsfun
global nofucall
global method 
global n1
global n2  
global k1 
global k2 
global t1
global t2
global x1
global x2
global Y 
global r1
global r2 
global mu1
global mu2 
global l1
global l2
global pvec1
global pvec2
  
nofucall=nofucall+1;
  
m1=length(x1);
m2=length(x2);
t1(pvec1)=x(1:l1);
t2(pvec2)=x(l1+1:l1+l2);

if method==1                               % Unconstrained approximation
  [A,RES,Fmat]=uncapp(m1, m2, n1, n2, k1, k2, t1, t2, x1, x2, Y);
  F=reshape(Fmat,m1*m2,1);
elseif method==2                           % Unconstrained smoothing
  [A,RES,Fmat]=uncsmo(m1, m2, n1, n2, k1, k2, t1, t2, x1, x2, Y, r1, r2, ...
                      mu1, mu2);
  F=reshape(Fmat,(m1+n1-r1)*(m2+n2-r2),1);
end % if method 

% dummy Jacobian
FJac=[];
