function [f,gradf]=npfun(x);
% function [f,gradf]=npfun(x);
%
% compute residual of reduced functional and set dummy gradient
% gradf=[]

% get global variables for npfun
global nofucall
global method 
global n1
global n2  
global k1 
global k2 
global t1
global t2
global x1
global x2
global Y 
global r1
global r2 
global mu1
global mu2 
global l1
global l2
global pvec1
global pvec2
  
nofucall=nofucall+1;
  
m1=length(x1);
m2=length(x2);
t1(pvec1)=x(1:l1);
t2(pvec2)=x(l1+1:l1+l2);

if method==1                               % Unconstrained approximation
  [A,RES]=uncapp(m1, m2, n1, n2, k1, k2, t1, t2, x1, x2, Y);
elseif method==2                           % Unconstrained smoothing
  [A,RES]=uncsmo(m1, m2, n1, n2, k1, k2, t1, t2, x1, x2, Y, r1, r2, mu1, mu2);
end % if method 

% residual of reduced functional
f=RES^2;

% dummy gradient
gradf=[];