function ok=chbound(n, k, p, L, U)
% function ok=chbound(n, k, p, L, U)
% check bounds
%
% check consistency of bounds on coefficients for p-th derivatives
%
%    L_j <= alpha^(p)_j <= U_j  j=p+1,..,n
%
% Input:                n;    number of B-splines
%                       k;    order of B-Splines
%                       p;    order of derivative in constraints
%               L[1..n-p];    lower bounds on alpha^(p)
%               U[1..n-p];    upper bounds on alpha^(p)
%
% Output:           ok= 1;    strict consistency
%                   ok= 0;    non-strict consistency
%                   ok=-1;    no consistency

if L <= U
  if L < U
    ok=1;
  else
    ok=0;
  end
else
  ok=-1;
end