% menu item: load

while 2,
  clc
  choice1=menu('Load','Data points','Spline Parameter',...
      'Free knots','Constraints','Quit');
  
  if ((choice1<=0) | (choice1>=5))
    break
  end            
      
  if choice1==1                               % Data points
    while 3,
      clc
      choice2=menu('Read data points','Keyboard','M-File',...
          'RPN14 data','Titanium data','Quit');
        
      if ((choice2<=0) | (choice2>=5))
        break
      end   
          
      if choice2==1                           % Keyboard
        x=zeros(m,1);
        y=zeros(m,1);
        for i=1:m
          clc
          home
          % Input data abscissae x
          x(i)=input(['x( ' num2str(i) ' ): ']);
          % Input data values y
          y(i)=input(['y( ' num2str(i) ' ): ']);         
        end % for i
      elseif choice2==2                       % M-File
        % read ASCII-File with x and y in two columns
        Filename=uigetfile('*.m','Enter File name:');
        fid=fopen(Filename);
        matrix=fscanf(fid,'%g %g',[2 inf]);
        x=matrix(1,:)';
        y=matrix(2,:)';
        fclose(fid);
        clear matrix
        m=length(x);
      elseif choice2==3                       % RPN14 data
        x(1)=7.99; y(1)=0;
        x(2)=8.09; y(2)=2.76429e-5;
        x(3)=8.19; y(3)=4.37498e-2;
        x(4)=8.70; y(4)=1.69183e-1;
        x(5)=9.20; y(5)=4.69428e-1;
        x(6)=10.00;y(6)=9.43740e-1;
        x(7)=12.00;y(7)=9.98636e-1;
        x(8)=15.00;y(8)=9.99919e-1;
        x(9)=20.00;y(9)=9.99994e-1;
        x=x(:);
        y=y(:);
        m=length(x);
      elseif choice2==4                       % Titanium data
        [x,y]=titanium;
        x=x(:);
        y=y(:);
        m=length(x);
      end % if choice2
    end % while 3
  elseif choice1==2                           % Spline Parameter
    while 3,
      clc
      choice2=menu('Load Spline parameter','Keyboard','M-File',...
          'Standard knotsequences','Quit');
      
      if ((choice2<=0) | (choice2>=4))
        break
      end   

      alpha=zeros(n,1);
      if choice2==1                           % Keyboard
        % Input inner knots of knot sequence t
        t=zeros(n+k,1);
        for i=k:n+1
          clc
          home
          t(i)=input(['Input inner knot t( ' num2str(i) ' ): ']);
        end % for i
            
        t(1:k-1)=t(k).*ones(k-1,1); 
        t(n+2:n+k)=t(n+1).*ones(k-1,1);
      elseif choice2==2                       % M-File input
        % read ASCII-File with t and alpha in two columns
        Filename=uigetfile('*.m','Enter File name:');
        fid=fopen(Filename);
        matrix=fscanf(fid,'%g %g',[2 inf]);
        t=matrix(1,:)';
        alpha=matrix(2,1:length(t)-k)';
        fclose(fid);
        clear matrix        
        
        n=length(t)-k;
      elseif choice2==3                       % Standard knotsquences
        while 4,
          clc
          choice3=menu('Standard knotsequences',...
              'equidistant wrt abscissae',...
              'equidistant wrt chord length','Quit');
          
          if ((choice3<=0) | (choice3>=3))
            break
          end             
              
          t=zeros(n+k,1);
          if choice3==1                       % abscissae
            for j=1:k
              t(j)=x(1);
            end
            for j=k+1:n
              t(j)=x(1)+(j-k)*(x(m)-x(1))/(n-k+1);
            end
            for j=n+1:n+k
              t(j)=x(m);
            end
          elseif choice3==2                   % chord length
            % scale the variables x and y to get an effect in the chord
            % length
            maxy=max(abs(y));
            d=zeros(m,1);
            
            for i=2:m
              d(i)=d(i-1)+sqrt(((x(i)-x(i-1))/x(m))^2+((y(i)-y(i-1))/maxy)^2); 
            end
            % d(i) contains distance from i-th data point to first data
            % point via straight line segments
            
            % scaling the variables to (0,1)
            d=d./d(m);
                
            % locate the n-k inner knots t(n+k),...,t(n)
            % equidistant with respect to the distance d(i) 
            for j=1:n-k
              pj=1;
              while d(pj)< (j /(n-k+1)), 
                pj=pj+1; 
              end

              % interpolate linear between x(pj-1) and x(pj)
              knotinc=(j/(n-k+1)-d(pj-1))/(d(pj)-d(pj-1))*(x(pj)-x(pj-1));
              t(k+j)=x(pj-1)+knotinc;
            end % for j
           
            for j=1:k
              t(j)=x(1);
            end
            for j=n+1:n+k
              t(j)=x(m);
            end
          end % if choice3
        end % while 4
      end % if choice2
    end % while 3   
  elseif choice1==3                           % Free knots
    % Input number of free knots
    l=readnum('Number of free knots l <= n-k',n-k);
        
    pvec=zeros(l,1);
    if l==n-k
      allinner=readchar('Set all inner knots free (y/n)','y');
      if allinner=='y'
        for i=1:l
          pvec(i)=k+i;
        end
      else
        allinner='n'
      end
    else
      allinner='n'
    end
    
    if allinner=='n'
      for i=1:l
        clc
        home
        % Input index vector of free knots
        pvec(i)=input(['Enter index of ' num2str(i) ' -th free knot: ']);
      end % for i
    end
    
    EPSILON=readnum('Minimum distance between knots',0.0625);
        
  elseif choice1==4                           % Constraints
    while 3,
      clc
      choice2=menu('Set bounds for derivatives','Positivity',...
          'Monotonicity','Convexity','Interval-wise bounds for s',...
          'Interval-wise bounds for s''','Interval-wise bound for s''''',...
          'Check consistency','Clear all constraints','Quit');
        
      if ((choice2<=0) | (choice2>=9))
        break
      end   
          
      if choice2==1                           % Positivity
        p=0;
        L=zeros(n,1);
        U=inf.*ones(n,1);
      elseif choice2==2                       % Monotonicity
        p=1;
        L=zeros(n-1,1);
        U=inf.*ones(n-1,1);
      elseif choice2==3                       % Convexity
        p=2;
        L=zeros(n-2,1);
        U=inf.*ones(n-2,1);
      elseif choice2==4                       % bounds for s
        p=0;
        [L,U]=inpbound(m,n,k,t,x,p);
      elseif choice2==5                       % bounds for s' 
        p=1;
        [L,U]=inpbound(m,n,k,t,x,p);
      elseif choice2==6                       % bounds for s''
        p=2;
        [L,U]=inpbound(m,n,k,t,x,p);
      elseif choice2==7                       % Check consistency 
        ok=chbound(n,k,p,L,U);
        if ok==1
          disp('Strict consistency');
        elseif ok==0
          disp('Consistency');
        else
          disp('No Consistency!');
        end
      elseif choice2==8                       % Clear all constraints
        clear p L U
      end % if choice2
    end % while 3
  end  % if choice1
end % while 2