% menu item: plot
npoints=500; % number of points to plot

% construct internal spline representation from knots and coefficients 
spl=spmak(t',alpha');

xmin=readnum('X minimal',x(1));
xmax=readnum('X maximal',x(m));

points=zeros(2,npoints);
points(1,:)=linspace(xmin,xmax,npoints);

while 2
  clc
  choice1=menu('Plot','Approximant','Derivative',...
      'Residual','Print to file','Quit');
  
  if ((choice1<=0) | (choice1>=5))
    break
  end   
 
  if choice1==1                               % Approximant
    points(2,:)=fnval(spl,points(1,:)); % compute points to plot
    figure
    plot(points(1,:),points(2,:)); % plot points of spline
    hold on
    
    minpoints=min(points(2,:));
    minxi=min(find((x-xmin)>=0));
    maxxi=max(find((xmax-x)>=0));
    plot(x(minxi:maxxi),y(minxi:maxxi),'ro'); % plot data values
    
    minti=min(find((t-xmin)>=0));
    maxti=max(find((xmax-t)>=0));
    plot(t(minti:maxti),minpoints*ones(length(t(minti:maxti))),'x');
    % plot knots of spline
    
    title('solid - spline function, o - data points, x - knots');
    hold off
  elseif choice1==2                           % Derivative
    plot_derivative=readnum('Plot r-th derivative of spline',1);
    points(2,:)=fnval(fnder(spl,plot_derivative),points(1,:)); 
    % compute points to plot
    figure
    plot(points(1,:),points(2,:));  % plot points of spline
    hold on
    
    minpoints=min(points(2,:));
    minti=min(find((t-xmin)>=0));
    maxti=max(find((xmax-t)>=0));
    plot(t(minti:maxti),minpoints*ones(length(t(minti:maxti))),'x');
    % plot knots of spline
    
    if plot_derivative==1
      titlestring=['solid - ' num2str(plot_derivative)];
      titlestring=[titlestring 'st order derivative, x - knots']; 
      title(titlestring);
    elseif plot_derivative==2
      titlestring=['solid - ' num2str(plot_derivative)];
      titlestring=[titlestring 'nd order derivative, x - knots']; 
      title(titlestring);
    elseif plot_derivative==3
      titlestring=['solid - ' num2str(plot_derivative)];
      titlestring=[titlestring 'rd order derivative, x - knots']; 
      title(titlestring);
    else
      titlestring=['solid - ' num2str(plot_derivative)];
      titlestring=[titlestring 'th order derivative, x - knots']; 
      title(titlestring);
    end
    hold off
  elseif choice1==3                           % Residual  
    residual=y-fnval(spl,x);
    figure
    plot(x(minxi:maxxi),residual(minxi:maxxi));
    title('Residual');
  elseif choice1==4                           % Print to file
    no=readnum('Enter number of figure to print',1);
    figure(no)
    filename=readchar('Enter file name','figure.eps');
    color=readchar('Color plot (y/n)','n');
    if color=='y'
      print( '-depsc2', filename, gcf );
    else
      print( '-deps2', filename, gcf );
    end
  end % if choice1
end % while 2
close all  

