% menu item: regularization parameter

while 2
  clc
  choice1=menu('Regularization parameter',...
      'Discrepancy principle','GCV','L-curve','Quit');  
  
  if ((choice1<=0) | (choice1>=4))
    break
  end            
    
  B=spcol(t',k,x');
  S=smooth(t,n,k,r);
  % compressed generalized singular value decomposition of (B,S)
  [UU,sm,XX,VV]=cgsvd(B,S);           
  
  if choice1==1                               % Discrepancy principle
    [alpha,RES]=uncapp(m,n,k,t,x,y);
    % RES is lower bound
    disp(['lower bound ' num2str(RES)]);
    delta=input('Upper bound on residual: ');
    [alpha,lambda]=discrep(UU,sm,XX,y,delta);
  elseif choice1==2                           % GCV
    % plot the GCV function and find its minimum --> lambda
    [lambda,GCV,lambda_gcv]=gcv(UU,sm,y,'Tikh');
  elseif choice1==3                           % L-curve
    % plot L-curve and find optimal regularization parameter lambda
    lambda=l_curve(UU,sm,y,'Tikh');
  end % if choice1
  
  format long e
  disp('Optimal regularization parameter: ');
  mu=lambda^2;
  disp(mu);
  [alpha,RES]=uncsmo(m,n,k,t,x,y,r,mu);
  disp('Norm of residual vector: ');
  disp(RES);
  format short  
end % while 2