% menu item: save

while 2,
  clc
  choice1=menu('Save','Data points','Spline parameter',...
      'Parameter','Residual','Quit');
 
  if ((choice1<=0) | (choice1>=5))
    break
  end
  
  if choice1==1                               % Data points
    while 3,
      clc
      choice2=menu('Save data points','Screen','M-File','Quit');
        
      if ((choice2<=0) | (choice2>=3))
        break
      end   
          
      if choice2==1                           % Screen
        fprintf(1,'\nData points\n\n');
        for i=1:m
          fprintf(1,'i= %5.0f; x= %25.12e; y= %25.12e\n',i,x(i),y(i));
        end
        fprintf(1,'\n');
      elseif choice2==2                       % M-File 
        Filename=uiputfile('*.m','Enter File name:');
        fid=fopen(Filename,'w');
        for i=1:m
          fprintf(fid,' %.14E %.14E\n',x(i),y(i));
        end
        fclose(fid);
      end % if choice2
    end % while 3 
  elseif choice1==2                           % Spline parameter
    while 3,
      clc
      choice2=menu('Save spline parameter','Screen','M-File','Quit');
        
      if ((choice2<=0) | (choice2>=3))
        break
      end   
     
      spl=spmak(t',alpha');
      % construct internal spline representation from knots and coefficients
      
      if choice2==1                           % Screen
        fprintf(1,'\nSpline parameter\n\n');
        for j=1:n
          fprintf(1,'j= %5.0f; t= %25.12e; alpha= %25.12e\n',j,...
              t(j),alpha(j));
        end
        for j=n+1:n+k
          fprintf(1,'j= %5.0f; t= %25.12e\n',j,t(j));
        end
        
        normr=norm(y-fnval(spl,x),2);
        fprintf(1,'\nResidual norm= %25.12e\n\n',normr);
      elseif choice2==2                       % M-File 
        Filename=uiputfile('*.m','Enter File name:');
        fid=fopen(Filename,'w');
        for j=1:n
          fprintf(fid,' %.14E %.14E\n',t(j),alpha(j));
        end
        for j=n+1:n+k
          fprintf(fid,' %.14E %.14E\n',t(j),0.0); 
        end 
        fclose(fid);
      end % if choice2
    end % while 3 
  elseif choice1==3                           % Parameter      
    fprintf(1,'\nNumber of data points m= %4.0f\n',m);
    fprintf(1,'Number of splines n= %4.0f\n',n);
    fprintf(1,'Order of splines k= %4.0f\n',k);
    fprintf(1,'Order of derivative in smoothing term r= %4.0f\n',r);
    fprintf(1,'Smoothing parameter mu= %25.12e\n',mu);
    
    if exist('L') & (size(L)>0)
      fprintf(1,'Order of derivative in constraints p= %4.0f\n',p);
      fprintf(1,'Lower and upper bound on derivative\n');
      for j=1:n-p
        fprintf(1,'j= %4.0f; L = %25.12e; U = %25.12e\n',j,L(j),U(j));
      end 
    end
    if exist('EPSILON')
      fprintf(1,'Minimum distance between knots = %25.12e\n',EPSILON); 
      fprintf(1,'Number of free knots l= %4.0f\n',l);
      fprintf(1,'Indices of free knots\n');
      for j=1:l
        fprintf(1,'j= %4.0f; pvec = %4.0f\n',j,pvec(j));
      end
    end
  elseif choice1==4                           % Residual
    while 3,
      clc
      choice2=menu('Save residual','Screen','M-File','Quit');
        
      if ((choice2<=0) | (choice2>=3))
        break
      end   
      
      spl=spmak(t',alpha');
      % construct internal spline representation from knots and coefficients
      residual=y-fnval(spl,x);
      normr=norm(residual,2);    
      
      if choice2==1                           % Screen
        fprintf(1,'\nResidual\n\n');
        for i=1:m
          fprintf(1,'i= %5.0f; x= %25.12e; r= %25.12e\n',...
              i,x(i),residual(i)); 
        end
      
        fprintf(1,'\nResidual norm= %25.12e\n\n',normr);
      elseif choice2==2                       % M-File 
        Filename=uiputfile('*.m','Enter File name:');
        fid=fopen(Filename,'w');
        for i=1:m
          fprintf(fid,' %.14E %.14E\n',x(i),residual(i)); 
        end
        
        fclose(fid);
      end % if choice2
    end % while 3     
  end  % if choice1
end % while 2





