function [F,FJac]=nlsfun(ttilde);
% function [F,FJac]=nlsfun(ttilde);
%
% compute residual function of reduced functional and set dummy Jacobian
% FJac=[]

% get global variables for nlsfun
global nofucall
global method 
global n 
global k 
global t 
global x 
global y 
global r 
global mu 
global p 
global L 
global U 
global l 
global pvec 
  
nofucall=nofucall+1;

m=length(x);
t(pvec)=ttilde;

if method==1                               % Unconstrained approximation
  [alpha,RES,F]=uncapp(m,n,k,t,x,y);
elseif method==2                           % Unconstrained smoothing
  [alpha,RES,F]=uncsmo(m,n,k,t,x,y,r,mu);
elseif method==3                           % Constrained approximation
  [alpha,RES,F]=conapp(m,n,k,t,x,y,p,L,U);
elseif method==4                           % Constrained smoothing
  [alpha,RES,F]=consmo(m,n,k,t,x,y,r,mu,p,L,U);  
end % if method 

% dummy Jacobian
FJac=[];
