function [f,gradf]=npfun(ttilde);
% function [f,gradf]=npfun(ttilde);
%
% compute residual of reduced functional and set dummy gradient
% gradf=[]

% get global variables for npfun
  global nofucall
  global method 
  global n 
  global k 
  global t 
  global x 
  global y 
  global r 
  global mu 
  global p 
  global L 
  global U 
  global l 
  global pvec 
  
nofucall=nofucall+1;

m=length(x);
t(pvec)=ttilde;

if method==1                               % Unconstrained approximation
  [alpha,RES]=uncapp(m,n,k,t,x,y);
elseif method==2                           % Unconstrained smoothing
  [alpha,RES]=uncsmo(m,n,k,t,x,y,r,mu);
elseif method==3                           % Constrained approximation
  [alpha,RES]=conapp(m,n,k,t,x,y,p,L,U);
elseif method==4                           % Constrained smoothing
  [alpha,RES]=consmo(m,n,k,t,x,y,r,mu,p,L,U);  
end % if method 

% residual of reduced functional
f=RES^2;

% dummy gradient
gradf=[];



